#pragma once

#include <windows.h>
#include <vcclr.h>
#include <math.h>

using namespace System;
using namespace System::Windows::Controls;
using namespace System::Windows::Threading;
using namespace System::Windows::Interop;

inline double AmplitudeToDB(double const a)
{
	return log10(a) * 20;
}

ref class ManagedGUI
{
public:
	ManagedGUI(UserControl ^uc)
	{
		Control = uc;
		MeterRectangle = dynamic_cast<System::Windows::Shapes::Rectangle ^>(Control->FindName("meter"));
		MaskRectangle = dynamic_cast<System::Windows::Shapes::Rectangle ^>(Control->FindName("mask"));
		mingain = NULL;
	}

	void StartTimer()
	{
		Timer = gcnew DispatcherTimer();
		Timer->Interval = TimeSpan(0, 0, 0, 0, 20);
		Timer->Tick += gcnew EventHandler(this, &ManagedGUI::TimerTick);
		Timer->Start();

	}

	void StopTimer()
	{
		Timer->Stop();
		Timer = nullptr;
	}

	void TimerTick(System::Object ^, System::EventArgs ^)
	{
		if (mingain == NULL)
		{
			MaskRectangle->Width = MeterRectangle->ActualWidth;
			return;
		}

		float unchanged = 123.0f;

		if (*mingain == unchanged)
			return;

		float g = *mingain;
		*mingain = unchanged;

		double db = min(0, max(-30, AmplitudeToDB(g)));
		double w = (db + 30.0) / 30.0 * MeterRectangle->ActualWidth;

		MaskRectangle->Width = w;
	}

public:
	HwndSource ^HS;
	UserControl ^Control;
	System::Windows::Shapes::Rectangle ^MeterRectangle;
	System::Windows::Shapes::Rectangle ^MaskRectangle;
	DispatcherTimer ^Timer;
	float *mingain;

};


class GUI
{
public:
	gcroot<ManagedGUI ^> MGUI;
	HWND Window;
};

extern void CreateGUI(GUI &gui, HWND parent);
